/*
-- ========================================================================== --
-- SISTEMA         : COMISSARIA                                               --
-- DATA DA CRIAO : INCIO - 16/01/2012                                      --
-- PROGRAMADOR     : WILLIAM AZEVEDO DE PAULA                                 --
-- OBJETIVOS       : - INCLUIR EM UM MAPA DE PRODUO OS PRODUTOS E AS        --
--		       SUBRECEITAS DE UMA RECEITA/SUBRECEITA PASSADA POR      --
--                     PARMETRO (P_RECORIGEM). ESTA PROCEDURE  RECURSIVA,   --
--                     DE FORMA QUE AO INSERIR UMA SUBRECEITA, A PROCEDURE   --
--                     CHAMADA NOVAMENTE PARA INCLUIR OS PRODUTOS E AS        --
--                     SUBRECEITAS DA MESMA, E ASSIM POR DIANTE.              --
--                                                                            --
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--  As Excesses encontram-se no formato:                                     --
--    '?'||Mensagem(12 caracteres)||Objeto com Erro || ''                    --
-- ========================================================================== --
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\1955_COCSTPO_GRAVA_PROD_SUBREC.sql
-- ========================================================================== --
*/

create or replace
PROCEDURE GRAVA_PROD_SUBREC (
   P_CDFILIAL   IN VARCHAR2,
   P_NRMAPAPROD IN VARCHAR2,
   P_CDCIA      IN VARCHAR2,
   P_CDSERVICO  IN VARCHAR2,
   P_CDSUBGRU   IN VARCHAR2,
   P_RECORIGEM  IN VARCHAR2,
   P_DTPRODUCAO IN DATE,
   P_QTTOTRECORI IN FLOAT,
   P_CDSETORRECORI IN VARCHAR2
   
)AS
  /*============================================================================
                     Declarao de Variveis
  ==============================================================================*/

   V_CDSERVICO      SERVMAPA.CDSERVICO%TYPE;  
   V_CDSUBGRU       SUBGRUSERVMAPA.CDSUBGRU%TYPE;
   V_ORIGEM         PRODRECSUBGRU.IDORIGPRODREC%TYPE;
   V_CDPRODREC      PRODUTO.CDPRODUTO%TYPE;
   V_ARVPRODREC     PRODUTO.CDARVPROD%TYPE;
   V_ARVRECORI      PRODUTO.CDARVPROD%TYPE;  
   V_QTPRODREC      PRODRECSUBGRU.QTPRODREC%TYPE;
   V_TXCOPRODREC    PRODRECSUBGRU.TXCOPRODREC%TYPE;  
   V_SGUNIDADE      UNIDMEDIDA.SGUNIDADE%TYPE;
   V_VRLOADPRODREC  PRODRECSUBGRU.VRLOADPRODREC%TYPE;
   V_NMPRODUTO      PRODUTO.NMPRODUTO%TYPE;
   V_DESCRECORI     PRODUTO.NMPRODUTO%TYPE;
   V_CDSETOR        PRODRECSUBGRU.CDSETORPRODREC%TYPE;
   V_SGSETORRES     SETOR.SGSETOR%TYPE;
   V_RECORIG        PRODRECSUBGRU.CDPRODREC%TYPE;
   V_CDTIPOCOMP     TCOMPPRO.CDTIPOCOMP%TYPE;
   V_CDESPEPROD     ESPEPROD.CDESPEPROD%TYPE;
   V_VRFATCORRPROD  COMPPROD.VRFATCORRPROD%TYPE;
   V_CDTPCORTEPROD  COMPPROD.CDTPCORTEPROD%TYPE;
   
   
   V_CONTA1         INTEGER; 
   V_CONTA_TCOMPRO  INTEGER;
   V_CONTA_PRODREC  INTEGER;
   V_QTRENDREC FLOAT;
  /*============================================================================
                     Declarao de Cursores
  ==============================================================================*/
  
  --Cursor para Buscar os produtos e subreceitas de uma receita ou subreceita
  CURSOR PROD_SUBREC IS
      SELECT PR.CDSERVICO,PR.CDSUBGRU,PR.ORIGEM,
           PR.CDPRODUTO,PR.CODIGO, PR.QTPRODSUMA,PR.TXCOPRODSUMA,
           PR.SGUNIDADE,PR.VRLOADPSUMA,
           PR.NMPRODUTO,SR.CDSETOR, SR.SGSETOR AS SGSETORRES,
           PR.RECORIG,PR.VRFATCORRPROD,PR.CDTPCORTEPROD 
      FROM SETOR SR,
         (
         
         SELECT P_CDSERVICO AS CDSERVICO,P_CDSUBGRU AS CDSUBGRU,PR.CDPRODUTO,PR.CDARVPROD AS CODIGO,
                 CP.QTINSUMO AS QTPRODSUMA,'' AS TXCOPRODSUMA,PR.SGUNIDADE,
                 0 AS VRLOADPSUMA,
                 NVL(SE.CDSETOR,P_CDSETORRECORI) AS CDSETOR,
                 PR.NMPRODUTO,'PR' AS ORIGEM,
                 P_RECORIGEM AS RECORIG,CP.VRFATCORRPROD,CP.CDTPCORTEPROD
         FROM COMPPROD CP, PRODUTO PR, TIPOINSU TI, SETOR SE, TIPOCORTE TP
          WHERE (CP.CDPRODUTO    = P_RECORIGEM  ) AND
          (CP.CDESPEPROD   = V_CDESPEPROD       ) AND
          (CP.CDTIPOCOMP   = V_CDTIPOCOMP       ) AND
          (CP.CDPRODINSUMO = PR.CDPRODUTO       ) AND
          (CP.CDTIPOINSU   = TI.CDTIPOINSU(+ )  ) AND
          (PR.IDPRODCOMISS IS NULL              ) AND
          (CP.CDSETORPROD  = SE.CDSETOR(+)      ) AND
          (TP.CDTIPOCORTE(+)  = CP.CDTPCORTEPROD)
         
          UNION ALL
                
          SELECT P_CDSERVICO AS CDSERVICO,P_CDSUBGRU AS CDSUBGRU,PR.CDPRODUTO,PR.CDARVPROD AS CODIGO,
                 CP.QTINSUMO AS QTPRODSUMA,'' AS TXCOMRECSUMA,PR.SGUNIDADE,
                 0 AS VRLOADPSUMA, NVL(PR.CDSETOR,P_CDSETORRECORI) AS CDSETOR,
                 PR.NMPRODUTO,'SR' AS ORIGEM,
                 P_RECORIGEM AS RECORIG,0 AS VRFATCORRPROD, '' AS CDTPCORTEPROD
          FROM COMPPROD CP, PRODUTO PR, TIPOINSU TI
          WHERE (CP.CDPRODUTO    = P_RECORIGEM     ) AND
                (CP.CDESPEPROD   = V_CDESPEPROD    ) AND
                (CP.CDTIPOCOMP   = V_CDTIPOCOMP    ) AND
                (CP.CDPRODINSUMO = PR.CDPRODUTO    ) AND
                (CP.CDTIPOINSU   = TI.CDTIPOINSU(+)) AND
                (PR.IDPRODCOMISS = '3')          
        )  PR
      
      WHERE (SR.CDSETOR(+) = PR.CDSETOR)
      ORDER BY ORIGEM,CODIGO;


BEGIN

   SELECT NVL(MAX(QTRENDRECLOC),0)
   INTO V_QTRENDREC
   FROM RENDLOCAL
   WHERE (CDFILIAL  = P_CDFILIAL ) AND
         (CDRECEITA = P_RECORIGEM);
   IF V_QTRENDREC = 0 THEN
      /* Rendimento Padro */
      SELECT NVL(MAX(QTRENDRECPAD),0)
      INTO V_QTRENDREC
      FROM RENDPADRAO
      WHERE (CDRECEITA = P_RECORIGEM);
      
      IF V_QTRENDREC = 0 THEN
         V_QTRENDREC := 1;
      END IF;
   END IF;
      
   --Busca a Especificao tcnica vigente na data da produo 
   BEGIN
      SELECT CDESPEPROD 
      INTO V_CDESPEPROD 
      FROM ESPEPROD 
      WHERE
        CDPRODUTO = P_RECORIGEM AND
        DTVALESPEPRO = (SELECT MAX(DTVALESPEPRO) FROM ESPEPROD WHERE 
                        CDPRODUTO = P_RECORIGEM AND
                        DTVALESPEPRO <= P_DTPRODUCAO);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
        V_CDESPEPROD := NULL;  
   END;
              
    IF V_CDESPEPROD IS NULL THEN
    
       SELECT CDARVPROD,NMPRODUTO 
       INTO V_ARVRECORI,V_DESCRECORI 
       FROM PRODUTO 
       WHERE CDPRODUTO = P_RECORIGEM;       
       
       RAISE_APPLICATION_ERROR( -20502, '?RecSemEspTec'||V_ARVRECORI||'-'||V_DESCRECORI||'', false);   
          /*  Gerao Interrompida. A receita ||V_ARVRECORI||'-'||V_DESCRECOR|| no possui
              especificao tcnica vigente na data de produo informada.*/
    END IF;
                    
    --Verifica se h tipo de composio padro cadastrada
    SELECT COUNT(*) 
    INTO V_CONTA_TCOMPRO
    FROM  TCOMPPRO 
    WHERE
      (CDPRODUTO  = P_RECORIGEM  ) AND
      (CDESPEPROD = V_CDESPEPROD ) AND
      (IDTCOMPPROC = 'S'         );
   
   --Se houver um nico tipo de composio marcado com "Padro de OP", busca o mesmo 
   IF V_CONTA_TCOMPRO = 1 THEN 

      SELECT CDTIPOCOMP
      INTO V_CDTIPOCOMP
      FROM TCOMPPRO 
      WHERE
      (CDPRODUTO  = P_RECORIGEM  ) AND
      (CDESPEPROD = V_CDESPEPROD ) AND
      (IDTCOMPPROC = 'S');
          
   --Se no tiver composio marcada como padro, retorna erro
   ELSIF V_CONTA_TCOMPRO <= 0 THEN
   
      SELECT CDARVPROD,NMPRODUTO 
      INTO V_ARVRECORI,V_DESCRECORI 
      FROM PRODUTO 
      WHERE CDPRODUTO = P_RECORIGEM;      
      
      RAISE_APPLICATION_ERROR( -20502, '?RecSemComPad'||V_ARVRECORI||'-'||V_DESCRECORI||'', false);
      /*  Gerao Interrompida. A receita ||V_ARVRECORI||'-'||V_DESCRECOR|| no possui
           composio Padro para a especificao tcnica vigente.*/
      
   --Se houver mais de uma marcada como padro (inconsistncia no Banco), retorna erro
   ELSIF V_CONTA_TCOMPRO > 1 THEN
      
      SELECT CDARVPROD,NMPRODUTO 
      INTO V_ARVRECORI,V_DESCRECORI 
      FROM PRODUTO 
      WHERE CDPRODUTO = P_RECORIGEM;      
      
      RAISE_APPLICATION_ERROR( -20502, '?RecVarComPad'||V_ARVRECORI||'-'||V_DESCRECORI||'', false);
      /*  Gerao Interrompida. A receita ||V_ARVRECORI||'-'||V_DESCRECOR|| possui mais
          de um tipo de composio marcado como "Padro de OP" para a especificao tcnica vigente.*/      
   END IF;
   
   V_CONTA1 := 0; 
   OPEN PROD_SUBREC; --Busca e percorre todos os produtos e subreceitas de uma receita ou subreceita
   LOOP
      
      FETCH PROD_SUBREC INTO V_CDSERVICO,V_CDSUBGRU,V_ORIGEM,V_CDPRODREC,V_ARVPRODREC, V_QTPRODREC,V_TXCOPRODREC, V_SGUNIDADE,
                             V_VRLOADPRODREC,V_NMPRODUTO,V_CDSETOR,V_SGSETORRES, V_RECORIG,V_VRFATCORRPROD,V_CDTPCORTEPROD;
      EXIT WHEN PROD_SUBREC%NOTFOUND;
      V_CONTA1 := V_CONTA1 + 1; --Conta quantas vezes entrou no Loop.      
      
      --=================INSERIR OS PRODUTOS/SUBRECEITAS DS RECEITA/SUBRECEITA NO MAPA============================
      
         --Verifica se a Receita/produto j est cadastrada para a mesma receita de origem
         SELECT COUNT(*) INTO V_CONTA_PRODREC 
         FROM PRODRECSUBGRU
         WHERE
            (CDFILIAL    = P_CDFILIAL  )  AND
            (NRMAPAPROD  = P_NRMAPAPROD)  AND
            (CDSERVICO   = P_CDSERVICO )  AND
            (CDCIA       = P_CDCIA     )  AND
            (CDSUBGRU    = P_CDSUBGRU  )  AND
            (CDPRODREC   = V_CDPRODREC )  AND
            (CDRECORIGEM = P_RECORIGEM );  
          IF V_CONTA_PRODREC = 0 THEN
          BEGIN 
               --Se no estiver, insere o mesmo e seus produtos e subreceitas, caso seja uma receita
               INSERT INTO PRODRECSUBGRU 
                   (CDFILIAL,NRMAPAPROD,CDSERVICO,CDCIA,CDSUBGRU,CDPRODREC,CDRECORIGEM,IDORIGPRODREC,
                    QTPRODREC,TXCOPRODREC,VRLOADPRODREC,CDSETORPRODREC,QTPRODRECTOT,VRFATCORRPROD,CDTPCORTEPROD,SGUNIDADE)
               VALUES
                   (P_CDFILIAL,P_NRMAPAPROD,P_CDSERVICO,P_CDCIA,P_CDSUBGRU,V_CDPRODREC,P_RECORIGEM,V_ORIGEM,
                    V_QTPRODREC,V_TXCOPRODREC,V_VRLOADPRODREC,V_CDSETOR,V_QTPRODREC*P_QTTOTRECORI/V_QTRENDREC,V_VRFATCORRPROD,V_CDTPCORTEPROD,V_SGUNIDADE);     
                    
               --Se for uma SubReceita, chama a Procedure recursivamente, para salvar os produtos e subreceitas da mesma
               IF (V_ORIGEM = 'R') OR (V_ORIGEM = 'SR') THEN
                   GRAVA_PROD_SUBREC(P_CDFILIAL,P_NRMAPAPROD,P_CDCIA,P_CDSERVICO,P_CDSUBGRU,V_CDPRODREC,P_DTPRODUCAO,V_QTPRODREC*P_QTTOTRECORI/V_QTRENDREC,V_CDSETOR); 
               END IF; 
          END;
        /*  ELSIF V_CONTA_PRODREC > 0 THEN
          BEGIN
             --Se j estiver cadastrado, apenas acrescenta a quantidade a se produzir da receita
             UPDATE PRODRECSUBGRU
                SET QTPRODREC = QTPRODREC + V_QTPRODREC
             WHERE
                (CDFILIAL    = P_CDFILIAL  ) AND
                (NRMAPAPROD  = P_NRMAPAPROD) AND
                (CDSERVICO   = P_CDSERVICO ) AND
                (CDCIA       = P_CDCIA     ) AND
                (CDSUBGRU    = P_CDSUBGRU  ) AND
                (CDPRODREC   = V_CDPRODREC ) AND
                (CDRECORIGEM = P_RECORIGEM );  
          
          END;*/
          END IF;
                    
      --==========================================================================================================
      
     
   
   END LOOP;
   CLOSE PROD_SUBREC;
   
   IF V_CONTA1 <= 0 THEN -- Se no entrar nenhuma vez no Loop,  porque no h composicao para a receita, e ento retorna erro
       
       SELECT CDARVPROD,NMPRODUTO 
       INTO V_ARVRECORI,V_DESCRECORI 
       FROM PRODUTO 
       WHERE CDPRODUTO = P_RECORIGEM;       
       
       RAISE_APPLICATION_ERROR( -20502, '?RecSemComPad'||V_ARVRECORI||'-'||V_DESCRECORI||'', false);   
          /*  Gerao Interrompida. A receita ||V_ARVRECORI||'-'||V_DESCRECOR|| no possui
              composio Padro para a especificao tcnica vigente.*/
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_PREVISAO_PAX','0.00.000'); END;
/
