package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginPMEFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.RevisarQuantidadePMEPage;
import org.testng.annotations.Test;

public class RevisarQuantidadePMETest extends TestBase {
    MainPage mainPage;
    MainFlows mainFlows;
    RevisarQuantidadePMEPage pratopage;
    LoginPMEFlows loginpmeflows;

    //Tests
    @Test
    public void RevisarQtReceitaPadrao() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        pratopage = new RevisarQuantidadePMEPage();

        String usuario = "francielly.automacao";
        String senha = "Teknisa2023*";

        loginpmeflows.efetuarloginpme(usuario, senha);
        pratopage.AcessarTela();
        pratopage.TelaRevisarQuantidade();
    }

    //Test 2 - Receita Tipo Cardapio
    @Test
    public void RevisarQtReceitaTipoCard() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        pratopage = new RevisarQuantidadePMEPage();

        String usuario = "francielly.automacao";
        String senha = "Teknisa2023*";


        loginpmeflows.efetuarloginpme(usuario, senha);
        pratopage.AcessarTela();
        pratopage.TelaRevisarQuantidade();
        pratopage.ReceitaTipoCard();
        pratopage.InformarQuantidade();
        pratopage.SelecionarArvoredePrato();
        pratopage.ConfirmarAlteracao();
    }


    //Test 3 - Receita Tipo Cardapio
    @Test
    public void RevisarQtReceitaLocal() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        pratopage = new RevisarQuantidadePMEPage();

        String usuario = "francielly.automacao";
        String senha = "Teknisa2023*";

        loginpmeflows.efetuarloginpme(usuario, senha);
        pratopage.AcessarTela();
        pratopage.TelaRevisarQuantidade();
        pratopage.ReceitaLocal();
    }
    //Test 4 - Receita Tipo Cardapio
    @Test
    public void RevisarServico() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        pratopage = new RevisarQuantidadePMEPage();

        String usuario = "francielly.automacao";
        String senha = "Teknisa2023*";

        loginpmeflows.efetuarloginpme(usuario, senha);
        pratopage.AcessarTela();
        pratopage.TelaRevisarQuantidade();
        pratopage.ReceitaServico();
    }
}
